Redmine - Feature #3058

Show issue history using tabs
2009-03-27 00:07 - Anonymous

Status: Closed Start date: 2009-03-26
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

We have some issues where there are so many Status/priority/custom fields changes that you have to scroll heaps to find the useful

messages that users have written.

It would be nice to be able to filter out things from the issue history. For example, next to the "History" text you could have the links
"Show All" and "Show Messages". Selecting "Show Messages" would only show non-empty messages. It would also be great to
remember the last selected option for the remaining session at a minimum (globally, probably not per issue to avoid overheads), or

have a default in the user preferences.

Related issues:

Related to Redmine - Feature #3046: Mix associated revisions with journal ent...
Related to Redmine - Feature #15409: Is it possible to view History section i...
Related to Redmine - Feature #4487: Add better presentation of issue status h...
Related to Redmine - Feature #5061: Show time log entries in issue history
Related to Redmine - Feature #16052: Consider a better associated revisions b...
Related to Redmine - Feature #21585: "Associated revisions" to be minimized /...
Related to Redmine - Defect #31438: Incorrect position of the "Associated rev...
Related to Redmine - Defect #31599: 'selected’ class disappears from the tab ...
Related to Redmine - Defect #32198: Issues associated revisions not showing d...
Related to Redmine - Defect #32529: The end of the URL is replaced with "unde...

Related to Redmine - Defect #33338: Property changes tab does not show journa...

Has duplicate Redmine - Feature #13298: Grouping issue history (activity) in ...

Has duplicate Redmine - Feature #8536: Separate notes/comments from issue upd...

New

New

New

Closed
Closed
Closed
Closed
Closed
Closed
Closed
Closed
Closed
Closed

2009-03-25

2009-12-25
2010-03-12

2011-06-06

Associated revisions

Revision 18271 - 2019-06-20 09:06 - Jean-Philippe Lang

Allow tabs to have a custom action (#3058).

Patch by Marius BALTEANU.

Revision 18272 - 2019-06-20 09:07 - Jean-Philippe Lang
Show issue history in tabs (#3058).

Patch by Marius BALTEANU.

Revision 18273 - 2019-06-20 09:08 - Jean-Philippe Lang
Move changesets to its own tab (#3058).

Patch by Marius BALTEANU.

Revision 18274 - 2019-06-20 09:11 - Jean-Philippe Lang
Add time entries tab to issue history tabs (#3058).

Patch by Marius BALTEANU.

Revision 18275 - 2019-06-20 09:12 - Jean-Philippe Lang
Load changesets and time entries tabs async (#3058).
Patch by Marius BALTEANU.

Revision 18276 - 2019-06-20 09:13 - Jean-Philippe Lang
Load remote tab only once (#3058).

Patch by Marius BALTEANU.

Revision 18277 - 2019-06-20 09:13 - Jean-Philippe Lang
User preference for issue history default tab (#3058).
Patch by Marius BALTEANU.

Revision 18278 - 2019-06-20 09:14 - Jean-Philippe Lang
Remove history label and no data (#3058).

Patch by Marius BALTEANU.

Revision 18281 - 2019-06-20 09:40 - Go MAEDA
Update locales (#3058).

Revision 18311 - 2019-06-22 02:20 - Go MAEDA

"selected" class is wrongly removed from journal edit tabs when switching the issue history tabs (#3058, #31599).

Patch by Marius BALTEANU.

Revision 18328 - 2019-07-12 12:42 - Go MAEDA

Fix the compatibility problem with Internet Explorer 11 (#3058).

Patch by Yuichi HARADA.

Revision 18598 - 2019-10-06 01:57 - Go MAEDA

Fix that "Associated revisions" tab has no content when the user displays comments in reverse chronological order (#32198, #3058).

Patch by José Esteves.

History

#1 - 2009-03-27 00:09 - Anonymous

| didn't see any other issues like this when | submitted, but | just noticed that this is similar to #3037 - not a duplicate, but similar.

#2 - 2009-03-27 00:12 - Anonymous

| also just noticed that if #3046 were to be implemented, then it would work as another filter type in my proposal - "Show Associated Revisions

#3 - 2009-04-01 05:20 - Paul Quirk

I'm happy with Nick's proposal for filtering as this covers most of the problem | was talking about in #3037.

#4 - 2009-04-01 05:25 - Paul Quirk

One other counter to this would be to set the "Show All" or "Show messages" flag at the role level. You could still have the toggle at the "history" level
to override this.

#5 - 2010-09-21 19:40 - Anonymous

This issue seems to have grown stagnant but seems to be very helpful. At a minimum there should be the ability to filter out the history to show only
the notes added to an issue (and vice versa).

#6 - 2012-01-04 01:23 - Adam Sneller

+1
There is an Issue History Tab plugin that works with 1.2.2. But the comment feature is buggy. Of course if anyone wants to take a shot a fixing it...

Here is a link to the issue:
https://github.com/tastapod/redmine_issue_history_tabs/issues/4
#7 - 2012-07-15 23:45 - Kevin O

+1. The way | would envision this is simply, for both default and custom fields, have an option to select whether or not they show in the Issue History.

For instance, we have a custom field called "Order" which we use for a custom backlog view to let product managers sort what's next in the pipeline.
They move things around a lot, so the issue histories are cluttered up with perhaps a couple dozen or more messages of "Order changed to xx".
Being able to select to hide changes to that field would be great.

#8 - 2015-01-08 13:24 - Go MAEDA

- Related to Feature #15409: Is it possible to view History section in pages? added

#9 - 2015-09-23 09:04 - Go MAEDA

- Related to Feature #8536: Separate notes/comments from issue updates added

#10 - 2015-09-23 09:15 - Go MAEDA
- File show-all-journals.png added

- File show-notes-only.png added

- File show-notes-only.diff added

- Priority changed from Low to Normal

| wrote a patch to implement this issue.
This patch introduces a new checkbox "Show notes only". We can hide/show details by checking it.

showing all journals, like current Redmine:

History Show notes only

Updated by Redmine Admin 9 minutes ago #1

+ Status changed from New to In Progress
* % Done changed from 0 to 50

Updated by Redmine Admin 8 minutes ago #2

+ Assignee set to Redmine Admin

Jackdaws love my big sphinx of quartz.

Updated by Redmine Admin 7 minutes ago #3
How razorback-jumping frogs can level six pigued gymnasts!

Updated by Redmine Admin less than a minute ago e

» Status changed from In Progress to Closed
* % Done changed from 50 to 100

Edit (%} Log time Watch Copy Delete

showing notes only:
show-notes-only.png

#11 - 2015-09-23 15:15 - Go MAEDA
- File show-notes-only-2.diff added

Go MAEDA wrote:

| wrote a patch to implement this issue.
This patch introduces a new checkbox "Show notes only". We can hide/show details by checking it.

Updated the patch (code cleanup): show-notes-only-2.diff

#12 - 2015-09-26 06:08 - Go MAEDA

- Target version set to Candidate for next major release

#13 - 2015-11-23 03:56 - Go MAEDA
- File trac-show-property-changes.png added
- Target version changed from Candidate for next major release to 3.2.0

Could this be included in 3.2.0? By this change, users can easily see all conversation on a issue. It increases productivity.

trac already has this feature (see the following screenshot).

» Attachments (0)

¥ Change History (3)

Oldest first Mewest first
Show property changes

Changed 3 years ago by Christian Boos comment:1
Rebased branch on latest #1002 changes, for using the latest styling for the '+' symbol = Reply
button: repos:cboos.git:clone-from-comment-t10012-r11112

Changed 9 months ago by Ryan .J Ollos comment:2

" Reply

= Milestone changed from next-dev-1.1.x to next-major-releases

Retargetting tickets to narrow focus for milestone:1.2. Pleasepove the ticket back to milestone: next-
dev-1.1.x if you intend to resalve it by milestone:1.2.

Changed 6 months ago by Ryan J Ollos comment:3

» Owner Christian Boos deleted \ = Raply

Hidden when “Show property changes” is off
» Modify Ticket

¥ Add Comment

#14 - 2015-11-23 13:35 - budo kaiman
- File RedmineTabs.png added
- File JiraTabs.png added

I don't think a checkbox looks very good there. I'm using the Redmine | Detailed T Time plugin which adds tabs for different sections. This
looks much better than a toggle check and offers more possible functionality. Tabs are used in Jira and it looks much cleaner.

Redmine plugin:
RedmineTabs.png

Jira:
JiraTabs.png

#15 - 2015-11-23 14:04 - Alexander Ryabinovskiy

budo kaiman wrote:

| don't think a checkbox looks very good there. I'm using the Redmine Issue Detailed Tabs & Time plugin which adds tabs for different sections.
This looks much better than a toggle check and offers more possible functionality. Tabs are used in Jira and it looks much cleaner.

| Agree, Jira's tabs variant is much better. It can be extended to show "Work Log", "Commits' tabs in the future.

#16 - 2015-11-24 08:13 - Sebastian Paluch

+1 for tabs

#17 - 2015-11-24 22:02 - Jean-Philippe Lang
- Target version changed from 3.2.0 to 3.3.0

| think we need a bit more time for this and 3.2.0 is now scheduled for the next week.

#18 - 2015-12-12 14:23 - Alexander Lyzhenkov

+1

#19 - 2016-02-16 04:14 - Go MAEDA
- File show-notes-only-v3.diff added
- File history-all.png added
- File history-notes.png added

Here is a updated patch: show-notes-only-v3.diff
We can use tabs to switch views.

"All" tab (notes, details) :

History Associated revisions
Revision cb3edf00 (diff)
All || Notes Added by Jean-Philippe Lang 8 months age

[ . . Use https links instead of http links in
i‘ Updated by Redmine Admin 5 months ago #1 ApplicationHelper#avatar_edit_link and Redmine::Info class
methods (#20243).

+ Status changed from New to In Progress

+ % Done changed from 0 to 50 R

git-svn-id: & http://svn.redmine.org/redmine/trunk@ 14413

fz Updated by Redmine Admin 5 months ago #2 293f8b46-1217-0410-a6f0-8f06a7374b81

« Assignee set to Redmine Admin

Jackdaws love my big sphinx of guartz. 276

fz Updated by Redmine Admin 5 months ago #3

How razorback-jumping frogs can level six pigued gymnasts! DS

1 Updated by Redmine Admin 5 months ago #4

« Status changed from In Progress to Closed
+ %% Done changed from 50 to 100

"Notes" tab (notes only) :
History Associated revisions

Revision cb3edf00 (diff)
All || Notes Added by Jean-Philippe Lang 8 months ago

[; . . Use https links instead of http links in
z Updated by Redmine Admin 5 months ago #2 ApplicationHelpergavatar_edit_link and Redmine::Info class
methods (#20243).

Assignee set to Redmine Admin
: 9 ! ' Patch by Mischa The Evil.

Jackdaws love my big sphinx of quartz. el git-svn-id: & http://svn.redmine.org/redmine/trunk@ 14413
e 293f8b46-1217-0410-a6f0-8f06a7374b81

[ 3

z Updated by Redmine Admin 5 months ago #3

How razorback-jumping frogs can level six piqued 2 £ &

gymnasts! ’

#20 - 2016-02-16 05:20 - Go MAEDA
- File show-notes-only-v3.diff added

Sorry, some files were missing in the patch.

#21 - 2016-02-16 05:20 - Go MAEDA

- File deleted (show-notes-only-v3.diff)

#22 - 2016-02-23 19:52 - Marius BALTEANU

Hi,

The solution with 2 tabs is good, but in my opinion it'll be very helpful for the users to have also the following tabs available:
- Spent time: with all the spent times added to the respective issue (of course, depending on the user rights)

- Activity: all the entries without notes

That means 4 tabs in totals:
- All (activity + notes)
- Activity
- Notes
- Spent Times

Maybe also the associated revisions can be added as tab, but I'm not sure about this one :)

If you're agree with this proposal we can contribute with an updated patch which implement the tabs.
Go MAEDA wrote:

Here is a updated patch: show-notes-only-v3.diff
We can use tabs to switch views.

#23 - 2016-02-23 20:25 - budo kaiman
Marius Balteanu wrote:
Hi,

The solution with 2 tabs is good, but in my opinion it'll be very helpful for the users to have also the following tabs available:
- Spent time: with all the spent times added to the respective issue (of course, depending on the user rights)
- Activity: all the entries without notes

That means 4 tabs in totals:
- All (activity + notes)
- Activity
- Notes
- Spent Times
Spent time would be a good tab to have, but Activity should definitely be part of this.
Marius Balteanu wrote:
Maybe also the associated revisions can be added as tab, but I'm not sure about this one :)

Personally, | think that the associated revisions should be a tab and not have the weird little sidebar thing. If the patch to implement tabs is accepted,
moving revisions to a tab should be done as a new feature, not part of this.

One general comment that | have about the patch (just from a quick glance, if | missed something let me know) is that the default tab probably
shouldn't always be "All". This could probably be handled in a few ways, below are some options (the second being my preferred method):

® Add a default tab setting
* Remember the last tab the user used with "All" as default at first

#24 - 2016-03-30 13:36 - Rupesh J
Hi,
During this implementation, Can you please also consider to provide a hook.

We have already defined some tabs in the ticket history region through a plugin development(currently overriding the corresponding partial).
Thanks.

#25 - 2016-05-07 09:45 - Jean-Philippe Lang
- Target version changed from 3.3.0 to 3.4.0

There's still some work to implement what is requested here (additional tabs, hook, memorization of last tab...)

#26 - 2016-05-07 09:51 - Go MAEDA

Jean-Philippe Lang wrote:

There's still some work to implement what is requested here (additional tabs, hook, memorization of last tab...)

| think that we can implement only show-notes-only-v3.diff in 3.3.0 and other requests in future releases.

#27 - 2016-06-08 15:38 - Dipan Mehta

This is great work going on.

There is another issue where the same was discussed in great detail - #4487 Do check and try to use some of these ideas.
Add related #4487.

#28 - 2016-06-08 15:46 - Go MAEDA
- Related to Feature #4487: Add better presentation of issue status history added

#29 - 2016-08-16 11:07 - Marc D.
Go MAEDA wrote:

Jean-Philippe Lang wrote:

There's still some work to implement what is requested here (additional tabs, hook, memorization of last tab...)

I think that we can implement only show-notes-only-v3.diff in 3.3.0 and other requests in future releases.

We got some issues with time spent feature after applying show-notes-only-v3.diff

If you click on the spent time summit in the issues description ( which links to /issues/1111/time_entries ) the issues just reloads instead of showing a
list of all time entries for the issue.

Anyone else got this problem?

#30 - 2016-10-19 09:30 - Artem -

Mark Mulder, did you manage to resolve the issue with time entries?

#31 - 2017-01-25 09:06 - Jean-Philippe Lang

- Target version changed from 3.4.0 to Candidate for next major release
Still some work to be done.

#32 - 2017-05-01 16:29 - Marius BALTEANU

- File 01_allow-tabs-to-have-a-custom-action.patch added

- File 02_show-issue-history-in-tabs.patch added

- File 03_move-changesets-to-its-own-tab.patch added

- File 04_add-time-entries-tab-to-issue-history-tabs.patch added

- File 05_load-changesets-and-time-entries-tabs-async.patch added
- File 06_load-remote-tab-only-once.patch added

- File issue_tabs.png added

I've attached a series of patches that implement this feature. Because the change is quite big, I've split the changes in multiple patches.

01_allow-tabs-to-have-a-custom-action.patch

This patch allows render_tabs to have custom action for onclick and also, make the partial rendering optional. In this way, tabs can use the same div
(partial) for displaying content.

02_show-issue-history-in-tabs.patch
This patch display issue history in three tabs:
e All: all journals
¢ Notes: only journals with notes
¢ History: only journals with history changes and without notes
The notes tab is default when the tab parameters doesn't exists.
03_move-changesets-to-its-own-tab.patch
This patch moves the associated revisions to a new tab and uses the look and feel from the journals to display the changesets.
04_add-time-entries-tab-to-issue-history-tabs.patch

This patch adds a new tab with the issue's visible spent times. The same look and feel from journals is used. Related to #5061.

05_load-changesets-and-time-entries-tabs-async.patch
This patch changes the way in which the changesets and time entries tabs are loaded in order to use ajax calls only on user request. In this way, we
speed up a little bit the issue show page. Journals are still loaded in the same time with the issue.

06_load-remote-tab-only-once.patch

| think it doesn't worth it to make an ajax call each time when the user clicks on changeset or time entries tabs

Let's discuss this implementation for Redmine version:3.5.0 (| think that the change is too big for 3.4.0). In Zitec, we're using from the beginning some
plugins that implement the tabs, but each time we had multiple issues with them. | really think that this feature is needed and also, having the tabs

async implemented, we can add more features in the future (some examples: affected branches and files from git revisions, time in state..).

Regarding the memorization of last tab, I'm not sure that is a good idea because if I'm on the changeset tab of the current issue, it doesn't mean that |
want to see the same tab first when | open the next issue. If it's really required, | prefer to have it configurable.

Any feedback is appreciated (attached is a printscreen with all 5 tabs).
#33 - 2017-05-02 02:43 - Go MAEDA
- Target version changed from Candidate for next major release to 4.1.0
Jean-Philippe Lang wrote:

Still some work to be done.

New patches have been submitted by Marius BALTEANU.
Let's consider implementing this feature.

#34 - 2017-05-02 13:21 - budo kaiman

Any feedback is appreciated (attached is a printscreen with all 5 tabs).

This looks excellent, one small comment | have is that it would be nice to have avatars shown in the "Associated Revisions" tab like they are for other
journals.

Regarding the memorization of last tab, I'm not sure that is a good idea because if I'm on the changeset tab of the current issue, it doesn't mean
that | want to see the same tab first when | open the next issue. If it's really required, | prefer to have it configurable.

| can understand why you feel that way, but | still believe it would be useful. Particularly, if | wanted to go through the time log or commit history of a
bunch of issues, | would scroll through and open them. If the last tab was remembered then I'd only have to change tab once when | started and then
change it back to whatever | want to see when | open the next issue after I'm done. If it were a configurable setting then I'd either have to change the
tab for each issue | view, or navigate the settings to change the default before and then after, both of which can be a bit cumbersome. If you still feel
opposed to it, that's fine but I'd at least like to express why | feel it would be valuable.

#35 - 2017-05-02 23:49 - Marius BALTEANU

budo kaiman wrote:
This looks excellent, one small comment | have is that it would be nice to have avatars shown in the "Associated Revisions" tab like they are for
other journals.

The avatars are already added, but they are missing from the screenshot because the feature is disabled on my local environment.
| can understand why you feel that way, but | still believe it would be useful. Particularly, if | wanted to go through the time log or commit history
of a bunch of issues, | would scroll through and open them. If the last tab was remembered then I'd only have to change tab once when | started
and then change it back to whatever | want to see when | open the next issue after I'm done. If it were a configurable setting then I'd either have

to change the tab for each issue | view, or navigate the settings to change the default before and then after, both of which can be a bit
cumbersome. If you still feel opposed to it, that's fine but I'd at least like to express why | feel it would be valuable.

It is a valid point of view. What about having the "Last visited tab" as an option in the default tab setting (along with the tabs)? Basically, each
Redmine administrator can set as default tab setting for issues one of the following options: All, Notes, History, Spent time, Associated Revisions and
Last visited tab.

#36 - 2017-05-03 13:02 - budo kaiman

It is a valid point of view. What about having the "Last visited tab" as an option in the default tab setting (along with the tabs)? Basically, each
Redmine administrator can set as default tab setting for issues one of the following options: All, Notes, History, Spent time, Associated Revisions
and Last visited tab.

| think that is a very sensible solution, though I'm not sure if it would be better as a user preference than an administrator setting.

#37 - 2017-05-07 02:18 - Mischa The Evil

- Related to Feature #12194: Source control revisions should be integrated as part of the history added

#38 - 2017-05-31 06:30 - Toshi MARUYAMA

- Related to Feature #5061: Show time log entries in issue history added

#39 - 2017-06-02 10:27 - Mischa The Evil

I really do like the tabbed solution for this issue.
My two cents on the patches provided in note-32 based on a visual scan of the patches and the posted screenshot:

e 'All' tab does not include spent time entries and associated revisions (this seems logical seeing where we are coming from, but it might be
unexpected behaviour for an 'All' tab)

o and if these were to be merged into the 'All' tab too, then it would provide a false overview of issues' journals as their items aren't journals

(only notes and property changes are journals)

to see all the associated revisions of an issue, one now has to click one more time (on the tab) than before (they were immediately visible along
the history), which might be a drawback for some (I can live with it though)
| think that a 'properties' or 'property changes' label for the 'history' tab is better considering its content and the terminology used throughout
Redmine (eg. see the label of the issue edit form [which is 'change properties'])
additional plugin hooks for the spent time and associated revisions tab views are not included
regarding the last visited tab memoization: | like the solution proposed by Marius in note-35, but, as Budo, | also like to see such a setting as a
user preference instead of a system-wide (admin) setting

All'in all I'm pretty positive about the patch series. This feature seems to be coming along nicely... Thanks Marius for your work on this.
#40 - 2017-06-27 01:20 - Marius BALTEANU

Thanks Mischa for your feedback.

Mischa The Evil wrote:

| really do like the tabbed solution for this issue.
My two cents on the patches provided in note-32 based on a visual scan of the patches and the posted screenshot:

e 'All' tab does not include spent time entries and associated revisions (this seems logical seeing where we are coming from, but it might be
unexpected behaviour for an 'All' tab)

o and if these were to be merged into the 'All' tab too, then it would provide a false overview of issues' journals as their items aren't
journals (only notes and property changes are journals)

1. It is better to rename the 'All' tab with the current label 'History'?
2. It'll be nice to have the time entries and associated revisions merged in an 'All' or 'Activity' tab, but maybe it'll be done in a future version.
¢ to see all the associated revisions of an issue, one now has to click one more time (on the tab) than before (they were immediately visible
along the history), which might be a drawback for some (I can live with it though)
¢ | think that a 'properties' or 'property changes' label for the 'history' tab is better considering its content and the terminology used throughout
Redmine (eg. see the label of the issue edit form [which is 'change properties'])

3. 'Changed properties' sounds good for you?

¢ additional plugin hooks for the spent time and associated revisions tab views are not included

4. I'll a update the patches to include the hooks.

e regarding the last visited tab memoization: | like the solution proposed by Marius in note-35, but, as Budo, | also like to see such a setting
as a user preference instead of a system-wide (admin) setting

5. I'll create a new patch for this feature. | think the best way to implement this is to have the both settings: one in admin to configure the default value
for new users, and one as a user preference.

#41 - 2017-07-02 12:03 - Marius BALTEANU

- File 01_allow-tabs-to-have-a-custom-action_v2.patch added
- File 02_show-issue-history-in-tabs_v2.patch added
- File 03_move-changesets-to-its-own-tab_v2.patch added
- File 04_add-time-entries-tab-to-issue-history-tabs_v2.patch added
- File 05_load-changesets-and-time-entries-tabs-async_v2.patch added
Updated the patch series (01-05) in order to apply cleanly to the current trunk and to include the feedback from Mischa:
e Renamed the tab "All" to "History"
e Renamed the tab "History" to "Property changes"
¢ Added hooks for changeset and time entries tabs
e Updated tests
Please remove the first version of patches (except 06_load-remote-tab-only-once.patch)

#42 - 2017-07-03 16:37 - Mischa The Evil

- File deleted (01_allow-tabs-to-have-a-custom-action.patch)

#43 - 2017-07-03 16:37 - Mischa The Evil
- File deleted (02_show-issue-history-in-tabs.patch)

#44 - 2017-07-03 16:37 - Mischa The Evil

- File deleted (03_move-changesets-to-its-own-tab.patch)

#45 - 2017-07-03 16:37 - Mischa The Evil
- File deleted (04_add-time-entries-tab-to-issue-history-tabs.patch)

#46 - 2017-07-03 16:37 - Mischa The Evil

- File deleted (05_load-changesets-and-time-entries-tabs-async.patch)

#47 - 2017-07-03 16:55 - Mischa The Evil
- Subject changed from User Filtering of Issue History to Show issue history using tabs
Marius BALTEANU wrote:

Updated the patch series (01-05) [...]

Nice! Thanks for incorporating my feedback. To summarize the remaining outstanding tasks:
® Add setting(s) for memoization of the last visited tab
o | don't think we need an admin setting as well as a user preference though. | think that only having a user preference will suffice.
¢ Merge time entries and associated revisions with journals into an 'All' or 'Activity' tab

Please remove the first version of patches (except 06_load-remote-tab-only-once.patch)

Done.

#48 - 2017-07-03 17:05 - Marius BALTEANU
Thanks!
Mischa The Evil wrote:
e Add setting(s) for memoization of the last visited tab
o | don't think we need an admin setting as well as a user preference though. | think that only having a user preference will suffice.
Is on my to do list.
¢ Merge time entries and associated revisions with journals into an 'All' or 'Activity' tab

I'll work on this after these patches are committed because the changes are quite big, hard to maintain and also, to be honest, | need a confirmation
from Jean-Philippe Lang that we're on the right way with the implementation.
#49 - 2017-07-03 20:28 - Mischa The Evil
Marius BALTEANU wrote:

e Merge time entries and associated revisions with journals into an 'All' or 'Activity' tab

I'll work on this after these patches are committed because the changes are quite big, hard to maintain and also, to be honest, | need a
confirmation from Jean-Philippe Lang that we're on the right way with the implementation.

Please don't get me wrong. | didn't mean to say that this particular change is a requirement before this patch serial can make it into the core. It is
something that could well be handled through a separate issue after integration of this issue. | just wanted to give a summary of things mentioned
throughout this issue which are not (yet) covered by your patches.

#50 - 2017-07-04 08:10 - Wim DePreter

If you change presentation of associated revisions, maybe you could keep #13715 in mind?

#51 - 2017-07-07 13:57 - Andrey Lobanov (RedSoft)

- File 01_allow-tabs-to-have-a-custom-action v2_fixed.patch added

Here is a fixed version of the patch. While viewing the repository entries, there was some problem - Tabs didn't opening, because of 'onclick’ action.

#52 - 2017-09-10 14:19 - Marius BALTEANU

- File user_pref.png added

- File 01_allow-tabs-to-have-a-custom-action_r16963.patch added

- File 02_show-issue-history-in-tabs_r16963.patch added

- File 03_move-changesets-to-its-own-tab_r16963.patch added

- File 04_add-time-entries-tab-to-issue-history-tabs_r16963.patch added

- File 05_load-changesets-and-time-entries-tabs-async_r16963.patch added

- File 06_load-remote-tab-only-once_r16963.patch added

- File 07 _user_preference_for_issue_history default_tab_r16963.patch added
- Assignee set to Jean-Philippe Lang

Andrey Lobanov, thanks for finding and fixing the issue. | reworked your fix a little bit in order to clean up the view file.

I'm attaching the updated patches which cleanly apply on the current trunk (r16963) and incorporate the changes from #26638 and test fixes for rails
5.

Also, I've finished the last patch for this ticket (07_user_preference_for_issue_history_default_tab_r16963.patch) which adds the possibility for the
users to select the default issue history tab as preference. The following options are available: notes (default), history, properties, time_entries,
changesets and last visited tab.

user_pref.png
Jean-Philippe Lang, | think that I've covered all the required changes and the patches are ready for review. I'm assigning you in order to take a call
regarding them (it'll be very useful for me if you can do this as soon as you can because there are a lot of changes and it is hard and time consuming
for me to maintain these 7 patches).

#53 - 2017-09-11 12:57 - budo kaiman

This looks great, thanks for all your hard work on this. Hopefully it can be incorporated soon.

#54 - 2017-10-15 09:07 - Go MAEDA

- Related to Feature #16052: Consider a better associated revisions block in the issue tracker added

#55 - 2017-11-08 03:47 - Mischa The Evil

- Related to deleted (Feature #12194: Source control revisions should be integrated as part of the history)

#56 - 2018-01-10 13:42 - Go MAEDA

- Related to Feature #21585: "Associated revisions" to be minimized / opened by click added

#57 - 2018-05-13 15:55 - Go MAEDA
- Has duplicate Feature #13298: Grouping issue history (activity) in issue history tabs added
#58 - 2018-07-27 11:39 - Marius BALTEANU

- Target version changed from 4.1.0 to 4.0.0

I'm setting target version to 4.0.0 in order to get at least a feedback from Jean-Philippe Lang. It is a long awaited feature, with more than 30 watchers,
a lot of related/duplicated issues and patches dragged from version 3.2.0. Also, I'm sure that once we implement this feature, we can make a lot of
improvements on top of it.

#59 - 2018-09-09 13:35 - Marius BALTEANU

- File deleted (01_allow-tabs-to-have-a-custom-action _v2.patch)

#60 - 2018-09-09 13:35 - Marius BALTEANU
- File deleted (02_show-issue-history-in-tabs_v2.patch)

#61 - 2018-09-09 13:35 - Marius BALTEANU
- File deleted (06 _load-remote-tab-only-once.patch)

#62 - 2018-09-09 13:35 - Marius BALTEANU
- File deleted (04_add-time-entries-tab-to-issue-history-tabs_v2.patch)

#63 - 2018-09-09 13:35 - Marius BALTEANU

- File deleted (03_move-changesets-to-its-own-tab_v2.patch)

#64 - 2018-09-09 13:36 - Marius BALTEANU

- File deleted (05_load-changesets-and-time-entries-tabs-async_v2.patch)

#65 - 2018-09-09 13:36 - Marius BALTEANU

- File deleted (01_allow-tabs-to-have-a-custom-action_r16963.patch)

#66 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (05_load-changesets-and-time-entries-tabs-async_r16963.patch)

#67 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (07 _user_preference_for_issue_history default_tab _r16963.patch)

#68 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (06_load-remote-tab-only-once_r16963.patch)

#69 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (04_add-time-entries-tab-to-issue-history-tabs_r16963.patch)

#70 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (03_move-changesets-to-its-own-tab_r16963.patch)

#71 - 2018-09-09 13:36 - Marius BALTEANU
- File deleted (02_show-issue-history-in-tabs_r16963.patch)

#72 - 2018-09-09 13:42 - Marius BALTEANU

- File 0001-allow-tabs-to-have-a-custom-action.patch added

- File 0002-show-issue-history-in-tabs.patch added

- File 0003-move-changesets-to-its-own-tab.patch added

- File 0004-add-time-entries-tab-to-issue-history-tabs.patch added

- File 0005-load-changesets-and-time-entries-tabs-async.patch added
- File 0006-load-remote-tab-only-once.patch added

- File 0007-user-preference-for-issue-history-default-tab.patch added

Updated the patch series to apply cleanly on the current trunk version.
#73 - 2018-09-15 09:15 - Jean-Philippe Lang
- Target version deleted (4.0.0)

Thank you for the patches series. | hope | will be able to review it soon but | have to unassign this from 4.0 if we want to release before the end of
september.

#74 - 2018-09-15 09:22 - Go MAEDA

- Target version set to 4.1.0

| have to unassign this from 4.0 if we want to release before the end of september.

It really makes sense to prioritize things to release 4.0 as soon as possible. Let's consider to deliver this in 4.1.0 :)

#75 - 2018-09-15 09:39 - Marius BALTEANU
Go MAEDA wrote:

| have to unassign this from 4.0 if we want to release before the end of september.

It really makes sense to prioritize things to release 4.0 as soon as possible. Let's consider to deliver this in 4.1.0 :)

I’'m happy with this decision.

#76 - 2018-11-26 06:23 - Bernhard Rohloff

As it's the end of November now and the release hasn't happened yet, may we reconsider an integration of this feature in 4.0.0 again?
The issue is quite old and provides a high UX improvement which | think many folks would love to see in the next major release.

#77 - 2018-12-16 15:57 - Marius BALTEANU

- File deleted (0001-allow-tabs-to-have-a-custom-action.patch)

#78 - 2018-12-16 15:57 - Marius BALTEANU
- File deleted (0002-show-issue-history-in-tabs.patch)

#79 - 2018-12-16 15:57 - Marius BALTEANU

- File deleted (0003-move-changesets-to-its-own-tab.patch)

#80 - 2018-12-16 15:57 - Marius BALTEANU
- File deleted (0004-add-time-entries-tab-to-issue-history-tabs.patch)

#81 - 2018-12-16 15:57 - Marius BALTEANU

- File deleted (0005-load-changesets-and-time-entries-tabs-async.patch)

#82 - 2018-12-16 15:57 - Marius BALTEANU
- File deleted (0006-load-remote-tab-only-once.patch)

#83 - 2018-12-16 15:57 - Marius BALTEANU

- File deleted (0007-user-preference-for-issue-history-default-tab.patch)

#84 - 2018-12-16 15:59 - Marius BALTEANU

- File 0001-allow-tabs-to-have-a-custom-action.patch added

- File 0002-show-issue-history-in-tabs.patch added

- File 0003-move-changesets-to-its-own-tab.patch added

- File 0004-add-time-entries-tab-to-issue-history-tabs.patch added

- File 0005-load-changesets-and-time-entries-tabs-async.patch added

- File 0006-load-remote-tab-only-once.patch added

2025-05-02 13/17



- File 0007-user-preference-for-issue-history-default-tab.patch added

Updated the patches series to apply cleanly on the current trunk. Jean-Philippe, please do not forget about this feature.

#85 - 2019-05-26 15:34 - Go MAEDA

- Related to Defect #31438: Incorrect position of the "Associated revisions" block when comments are displayed in reverse chronological order added

#86 - 2019-06-11 10:10 - Ko Nagase

Hi,

| hope that this functionality will be included on next Redmine 4.1.0 release.
Is there anything that | can help with this ?

#87 - 2019-06-20 08:20 - Marius BALTEANU

- File 0001-allow-tabs-to-have-a-custom-action.patch added

- File 0002-show-issue-history-in-tabs.patch added

- File 0003-move-changesets-to-its-own-tab.patch added

- File 0004-add-time-entries-tab-to-issue-history-tabs.patch added

- File 0005-load-changesets-and-time-entries-tabs-async.patch added
- File 0006-load-remote-tab-only-once.patch added

- File 0007-user-preference-for-issue-history-default-tab.patch added

- File 0008-Remove-history-label-and-no-data.patch added

Ko Nagase wrote:
Hi,
| hope that this functionality will be included on next Redmine 4.1.0 release.
Is there anything that | can help with this ?

No, you can't, it is Jean-Philippe decision on this feature.

In the meantime, I've updated the patch series to apply cleanly and I've added a new patch (0008-Remove-history-label-and-no-data.patch) to remove
the history label and the "No data" block when there are no history/spent times or revisions.

#88 - 2019-06-20 09:26 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Fixed

Thanks Marius for updating the patches. They are now committed, thanks for your hard work on this!

#89 - 2019-06-21 14:31 - Marius BALTEANU
- Related to Defect #31599: 'selected’ class disappears from the tab of the input field when switching the issue history tab added

#90 - 2019-06-21 14:43 - Marius BALTEANU

- Status changed from Closed to Reopened

A small problem was reported by Mizuki in #31599. I've attached there the fix.

#91 - 2019-06-21 14:52 - Marius BALTEANU

- Related to deleted (Feature #8536: Separate notes/comments from issue updates)

#92 - 2019-06-21 14:53 - Marius BALTEANU

- Has duplicate Feature #8536: Separate notes/comments from issue updates added

#93 - 2019-06-22 02:22 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:
A small problem was reported by Mizuki in #31599. I've attached there the fix.

Committed the patch in r18311. Thanks.

#94 - 2019-07-08 07:09 - Yuichi HARADA

In IE11 it gives this error on the console: Expected ')’

https://www.redmine.org/projects/redmine/repository/revisions/18276/diff/trunk/public/javascripts/application.js

IE11 does not seem to support Default function parameters.
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Functions/default_parameters#Browser_compatibility

#95 - 2019-07-08 07:19 - Marius BALTEANU
- Status changed from Closed to Reopened

- Assignee changed from Jean-Philippe Lang to Marius BALTEANU

#96 - 2019-07-08 07:45 - Yuichi HARADA
This patch works with IE11.

diff --git a/public/javascripts/application.js b/public/javascripts/application.js
index 7a2805d97..019b45dc4 100644
-—- a/public/javascripts/application. js
+++ b/public/javascripts/application. js
@@ -385,7 +385,8 @@ function showIssueHistory(journal, url) {
return false;

}

—-function getRemoteTab (name, remote_url, url, load_always = false) {
+function getRemoteTab (name, remote_url, url, load_always) {
+ load_always = load_always || false;

var tab_content = $('#tab-content-' + name);

tab_content.parent () .find('.tab-content') .hide();

This also solves.
https://www.redmine.org/issues/31433#note-12

#97 - 2019-07-12 09:51 - Marius BALTEANU
- Assignee deleted (Marius BALTEANU)
Yuichi HARADA wrote:

This patch works with IE11.

(-]

This also solves.
https://www.redmine.org/issues/31433#note-12

Thanks Yuichi for catching this issue. Your fix is good, it can be committed.

#98 - 2019-07-12 12:43 - Go MAEDA
- Status changed from Reopened to Closed
Yuichi HARADA wrote:

This patch works with IE11.

(-]

This also solves.
https://www.redmine.org/issues/31433#note-12

Committed. Thanks.
#99 - 2019-09-29 02:30 - Go MAEDA
- Assignee set to Jean-Philippe Lang

#100 - 2019-10-05 04:34 - Mischa The Evil

- Related to Defect #32198: Issues associated revisions not showing due to bad reference to Ivar instead of ivar added

#101 - 2019-11-29 06:12 - Go MAEDA
- Related to Defect #32529: The end of the URL is replaced with "undefined" in IE11 and Edge added

#102 - 2019-11-29 06:21 - Go MAEDA

- Status changed from Closed to Reopened

A cross-Browser compatibility issue caused by the changes has been reported as #32529.

#103 - 2019-12-07 16:33 - Marius BALTEANU
Go MAEDA wrote:

A cross-Browser compatibility issue caused by the changes has been reported as #32529.

I've posted a fix which is good enough for now, but I'm still looking for a better solution for the future. The problem is caused by this line
source:trunk/app/views/common/_tabs.html.erb#L27 which calls the onclick functions in a non element context.

#104 - 2019-12-09 13:40 - Jean-Philippe Lang

- Status changed from Reopened to Closed

#105 - 2020-04-15 03:00 - Ali Hamdan

Dears,

just an additional feature to mention it will be great if the PDF export of the issue will include the time entry(time+comment+custome fields) under
history

Thanks.

#106 - 2020-04-15 12:43 - Marius BALTEANU

Ali Hamdan wrote:

Dears,

just an additional feature to mention it will be great if the PDF export of the issue will include the time entry(time+comment+custome fields) under
history

Thanks.

Please open a new issue for this request.

#107 - 2020-04-22 14:48 - Go MAEDA
- Related to Defect #33338: Property changes tab does not show journals with both property changes and notes added

Files

show-all-journals.png 60.4 KB 2015-09-23 Go MAEDA
show-notes-only.png 38.4 KB 2015-09-23 Go MAEDA
show-notes-only.diff 2.31 KB 2015-09-23 Go MAEDA
show-notes-only-2.diff 2.26 KB 2015-09-23 Go MAEDA
trac-show-property-changes.png 69.2 KB 2015-11-23 Go MAEDA
RedmineTabs.png 9.94 KB 2015-11-23 budo kaiman
JiraTabs.png 12.8 KB 2015-11-23 budo kaiman
history-notes.png 52.1 KB 2016-02-16 Go MAEDA
history-all.png 78.3 KB 2016-02-16 Go MAEDA
show-notes-only-v3.diff 3.03 KB 2016-02-16 Go MAEDA
issue_tabs.png 157 KB 2017-05-01 Marius BALTEANU
01_allow-tabs-to-have-a-custom-action_v2_fixed.patch 1.45 KB 2017-07-07 Andrey Lobanov (RedSoft)
user_pref.png 207 KB 2017-09-10 Marius BALTEANU
0006-load-remote-tab-only-once.patch
0007-user-preference-for-issue-history-default-tab.patch
0005-load-changesets-and-time-entries-tabs-async.patch
